﻿using System;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Windows.Forms;

using TestLibrary;

namespace TestClient
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// TCP 클라이언트 채널
        /// </summary>
        private TcpClientChannel tcpClientChannel = null;

        /// <summary>
        /// 원격 객체
        /// </summary>
        private RemotableObject remoteObject;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 시작 버튼 클릭시 처리하기 - startButton_Click(sender, e)

        /// <summary>
        /// 시작 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void startButton_Click(object sender, EventArgs e)
        {
            this.tcpClientChannel = new TcpClientChannel();

            ChannelServices.RegisterChannel(this.tcpClientChannel, true);

            this.remoteObject = Activator.GetObject
            (
                typeof(RemotableObject),
                "tcp://localhost:" + this.portTextBox.Text + "/" + this.serverNameTextBox.Text + ""
            ) as RemotableObject;

            this.serverNameTextBox.Enabled = false;
            this.portTextBox.Enabled       = false;

            this.statusToolStripStatusLabel.Text = "상태 : 채널(" + this.tcpClientChannel.ChannelName + "), 연결...";
        }

        #endregion
        #region 메시지 텍스트 박스 텍스트 변경시 처리하기 - messageTextBox_TextChanged(sender, e)

        /// <summary>
        /// 메시지 텍스트 박스 텍스트 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void messageTextBox_TextChanged(object sender, EventArgs e)
        {
            this.remoteObject.SetMessage(this.messageTextBox.Text);
        }

        #endregion
    }
}