﻿namespace TestLibrary
{
    /// <summary>
    /// 캐시
    /// </summary>
    public class Cache
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 캐시
        /// </summary>
        private static Cache _cache = null;

        /// <summary>
        /// 관찰자
        /// </summary>
        private static IObserver _observer;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 부착하기 - Attach(observer)

        /// <summary>
        /// 부착하기
        /// </summary>
        /// <param name="observer">관찰자</param>
        public static void Attach(IObserver observer)
        {
            _observer = observer;
        }

        #endregion
        #region 인스턴스 구하기 - GetInstance()

        /// <summary>
        /// 인스턴스 구하기
        /// </summary>
        /// <returns>캐시</returns>
        public static Cache GetInstance()
        {
            if(_cache == null)
            {
                _cache = new Cache();
            }

            return _cache;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 메시지 설정하기 - SetMessage(message)

        /// <summary>
        /// 메시지 설정하기
        /// </summary>
        public void SetMessage(string message)
        {
            _observer.Notify(message);
        }

        #endregion
    }
}